> For the complete documentation index, see [llms.txt](https://docs.apryse.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.apryse.com/ios/changelogs/version-6/v6-9-3-68951.md).

# Version 6.9.3.68951 Changelog (December 18th, 2018)

World's #1 PDF SDK Library for Web, Mobile, Server, Desktop

* Version: 6.9.3.68951
* Release Date: December 18th, 2018
* Built with Xcode 10.1 (10B61)

## New

* A number of new APIs allow for UI customization without modifying the source code of the open source Tools UI framework.
  * It is now possible to easily add, rearrange and remove buttons from the main toolbars displayed by a [`PTDocumentViewController`](https://sdk.apryse.com/api/ios/Classes/PTDocumentViewController.html) or [`PTTabbedDocumentViewController`](https://sdk.apryse.com/api/ios/Classes/PTTabbedDocumentViewController.html).
  * It is now possible to easily add, rearrange and remove view controllers from a [`PTNavigationListsViewController`](https://sdk.apryse.com/api/ios/Classes/PTNavigationListsViewController.html) (which by default contains the document outline, annotation list and user bookmarks).
* The annotation permission API has been improved so that code is less complex and supports code completion. (See the API differences section below).
* The annotation toolbar now allows changing an annotation's style before it is created:

![](https://4149080208-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2FgY6xtY9ZQd9XMpvWlGM0%2Fuploads%2Fgit-blob-6b56286abfe3c62299caaad93cf8d6614f93117e%2F8d15f3b39e39a7aa946682afb04799e126b979df-640x852.gif?alt=media)

* The annotation style picker shows as a popover on iPads and large iPhones in landscape:

![](https://4149080208-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2FgY6xtY9ZQd9XMpvWlGM0%2Fuploads%2Fgit-blob-9b94dcef4dd261a1d2a7433ee9be84d05b7cd833%2F0b691ddf44983d355b365384ae55fe4bfbef3c7d-640x852.gif?alt=media)

* A new sample, **Showcase**, demonstrates a number of features of the Apryse SDK.

![](https://4149080208-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2FgY6xtY9ZQd9XMpvWlGM0%2Fuploads%2Fgit-blob-9cc132d2920c358f6cd772d375fd74f3ab36a9ea%2F38c4755114764671e1a59303d60fd700e6ebe607-828x1792.png?alt=media)

## API differences

* Customizing annotation permissions has changed. The new APIs are cleaner and easier to write as they employ properties with full code completion, vs. text strings that required consulting documentation. For example:

Version 6.9.3+ (new method):

{% tabs %}
{% tab title="Shell" %}
{% code lineNumbers="true" %}

```sh
toolManager.inkAnnotationPermission.canCreate = false
toolManager.inkAnnotationPermission.canEdit = false
toolManager.highlightAnnotationPermission.canCreate = false
toolManager.highlightAnnotationPermission.canEdit = false
```

{% endcode %}
{% endtab %}
{% endtabs %}

Version 6.8.7-6.9.2 (previous method):

{% tabs %}
{% tab title="Shell" %}
{% code lineNumbers="true" %}

```sh
toolManager.configure(with: ToolManagerConfiguration { builder in
    builder.annotPermissions = [
        .ink : [
            .canCreate : false,
            .canEdit : false,
        ],
        .highlight: [
            .canCreate: false,
            .canEdit: false,
        ],
    ]
})
```

{% endcode %}
{% endtab %}
{% endtabs %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.apryse.com/ios/changelogs/version-6/v6-9-3-68951.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
